<?php

require_once 'View.php';
require_once 'PageNavigation.php';
require_once 'HtmlSelect.php';

class Action {

  const defaultFuncName = "action_top";
  public $urlName;

  /**
   * 一ページあたりの情報数
   */
  const PageNum = 50;
  const PageNumLog = 10;
  
  // ダウンロードリスト関係
  
  function action_usrlist(){
    $pageNum = self::PageNum;
    if($this->isLogined()){
      $offset = isset($_GET['offset']) ? $_GET['offset'] : 0;
      
      $dao = new Dao();
      $count = $dao->countPermitDL();
      $usrDb = $dao->selectPermitDL($offset, $pageNum);
      
      $pageNavi = new PageNavigation($count, $offset, $pageNum);
      return View::usrList($usrDb, $pageNavi);
    }else{
      return View::loginForm();
    }   
  }

  function action_trade(){
    if($this->isLogined()){
      if(isset($_GET['txn_id'])){
        $tradeId = $_GET['txn_id'];
        $dao = new Dao();
        $goods = $dao->getPermitDL($tradeId);
        if(is_null($goods)){
          return View::error("Not Found Goods");
        }else{
          // 情報表示
          return View::trade($goods);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_stopdl(){
    if($this->isLogined()){
      if(isset($_GET['txn_id'])){
        $tradeId = $_GET['txn_id'];
        $dao = new Dao();
        $goods = $dao->getPermitDL($tradeId);
        if(is_null($goods)){
          return View::error("Not Found Goods");
        }else{
          $dao->updatePermitDLStop($tradeId);
          // 情報表示
          $goods = $dao->getPermitDL($tradeId);
          return View::trade($goods);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_extension(){
    if($this->isLogined()){
      if(isset($_GET['txn_id'])){
        $tradeId = $_GET['txn_id'];
        $dao = new Dao();
        $goods = $dao->getPermitDL($tradeId);
        if(is_null($goods)){
          return View::error("Not Found Goods");
        }else{
          $dao->updatePermitDL($tradeId, 5);
          // 情報表示
          $goods = $dao->getPermitDL($tradeId);
          return View::trade($goods);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_resetdl(){
    if($this->isLogined()){
      if(isset($_GET['txn_id'])){
        $tradeId = $_GET['txn_id'];
        $dao = new Dao();
        $goods = $dao->getPermitDL($tradeId);
        if(is_null($goods)){
          return View::error("Not Found Goods");
        }else{
          $dao->updatePermitDLResetCnt($tradeId, 5);
          // 情報表示
          $goods = $dao->getPermitDL($tradeId);
          return View::trade($goods);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_sendremail(){
    if($this->isLogined()){
      $dao = new Dao();
      if(isset($_GET['txn_id'])){
        $tradeId = $_GET['txn_id'];
        
        $dao = new Dao();
        $tradeDb = $dao->getPermitDL($tradeId);
        if(is_null($tradeDb)){
          return View::error("Not Permit");
        }else{
          $goodsName = $tradeDb['item_name'];
          $payerEmail = $tradeDb['payer_email'];
          $goodsId = $tradeDb['item_number'];
          $price = $tradeDb['price'];
          $mc_currency = $tradeDb['mc_currency'];
          $limitDate = $tradeDb['limitdate'];
          
          $this->sendPayerEmail($payerEmail, $tradeId, $goodsName, $goodsId, $price, $mc_currency, $limitDate);
          return View::sentReEmail($payerEmail, $goodsName);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_addbuyerform(){
    if($this->isLogined()){
      $dao = new Dao();
      $goodsDb = $dao->selectItem(0, 10000);
      $goodsList = array();
      foreach($goodsDb as $item){
        $goodsList[$item['item_number']] = $item['item_name'];
      }
      $tradeId = mb_substr("TX" . time(), 0, 49);
      if($dao->isExistPermitDL($tradeId)){
        $tradeId .= "a";
      }
      return View::addbuyerForm($goodsList, $tradeId);
    }else{
      return View::loginForm();
    }   
  }

  function action_addbuyer(){
    if($this->isLogined()){
      if(isset($_POST['tradeid'])
              && isset($_POST['email'])
              && isset($_POST['goodsid'])){
        $tradeId = $_POST['tradeid'];
        $buyerEmail = $_POST['email'];
        $goodsId = $_POST['goodsid'];

        $dao = new Dao();
        
        $errMsg = array();
        if(mb_strlen($tradeId) == 0){
          $errMsg[] = "Error Trade ID";
        }else{
          $tradeId = mb_substr($tradeId, 0, 49);
        }
        if($dao->isExistPermitDL($tradeId)){
          $errMsg[] = "Same Trade ID";
        }
               
        if(validateEmailString($buyerEmail) !== true){
          $errMsg[] = "Buyer Email";
        }
               
        $goodsDb = $dao->getItemById($goodsId);
        if(is_null($goodsDb)){
          $errMsg[] = "Not Found Goods";
        }
        $goodsName = $goodsDb['item_name'];
        $mc_gross = $goodsDb['mc_gross'];
        $mc_currency = $goodsDb['mc_currency'];
        
        if(count($errMsg) == 0){
          
          // 登録処理
          $dao->insertPermitDL($tradeId, $goodsId, "", $buyerEmail, _DEFAULT_TERM_);
          $limitDate = time() + (3600 * 24 * _DEFAULT_TERM_);
          $this->sendPayerEmail($buyerEmail, $tradeId, $goodsName, $goodsId, $mc_gross, $mc_currency, $limitDate);
//          $msgMail = getMailTextPayer($goodsName, $goodsId, $mc_gross, $mc_currency, _OWNER_EMAIL_, $url, $limitDate);			
//          mb_send_mail($buyerEmail, "ダウンロードのお知らせ",$msgMail, "From: " . _OWNER_EMAIL_);
        }
        
        if(count($errMsg) > 0){
          $goodsDb = $dao->selectItem(0, 10000);
          $goodsList = array();
          foreach($goodsDb as $item){
            $goodsList[$item['item_number']] = $item['item_name'];
          }
          $tradeId = mb_substr("TX" . time(), 0, 49);
          if($dao->isExistPermitDL($tradeId)){
            $tradeId .= "a";
          }
          return View::addbuyerForm($goodsList, $tradeId, $buyerEmail, $goodsId, $errMsg);
        }
        // 許可一覧表示
        $count = $dao->countPermitDL();
        $usrDb = $dao->selectPermitDL(0, self::PageNum);
        $pageNavi = new PageNavigation($count, 0, self::PageNum);
        return View::usrList($usrDb, $pageNavi);        
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  private function sendPayerEmail($payerEmail, $tradeId, $goodsName, $goodsId, $mc_gross, $mc_currency, $limitDate){
    $url = _SITE_URL_ . "download.php?txn_id="
            . urlencode(stripslashes($tradeId))
            . "&payer_email=" . urlencode(stripslashes($payerEmail));
    $msgMail = getMailTextPayer($goodsName, $goodsId, $mc_gross, $mc_currency, _OWNER_EMAIL_, $url, $limitDate);
    mb_send_mail($payerEmail, "ダウンロードのお知らせ",$msgMail, "From: " . _OWNER_EMAIL_);
  }
          
  function action_goodslist(){
    if($this->isLogined()){
      $dao = new Dao();
      $itemDb = $dao->selectItem(0, 10000);
      
      return View::goodsList($itemDb);
    }else{
      return View::loginForm();
    }   
  }
  
  function action_goods(){
    if($this->isLogined()){
      if(isset($_GET['id'])){
        $goodsId = $_GET['id'];
        $dao = new Dao();
        $goods = $dao->getItemById($goodsId);
        if(count($goods) == 0){
          return View::error("Not Found Goods");
        }else{
          // 商品情報表示
          return $this->viewGoods($dao, $goods['item_name'], $goods['item_number'], $goods['price'], $goods['mc_currency'], $goods['filename']);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  /**
   * 
   * @param Dao $dao
   * @param type $goodsName
   * @param type $goodsId
   * @param type $price
   * @param type $currency
   * @param type $fileName
   * @return type
   */
  private function viewGoods($dao, $goodsName, $goodsId, $price, $currency, $fileName){
    $certId = $dao->getSiteData("certid");
    $paypalCert = $dao->getSiteData("paypalcert");
    $myKey = $dao->getSiteData("myprvkey");
    $myCert = $dao->getSiteData("mycert");    
    if(is_null($certId) || is_null($paypalCert) || is_null($myKey) || is_null($myCert)){
      $button = "";
    }else{
      $buttonParams = array("cmd" => "_xclick",
          "business" => _OWNER_EMAIL_,
          "cert_id" => htmlspecialchars($certId),
          "charset" => "UTF-8",
          "item_name" => htmlspecialchars($goodsName),
          "item_number" => htmlspecialchars($goodsId),
          "amount" => $price,
          "currency_code" => htmlspecialchars($currency),
          "no_note" => 1,
          "no_shipping" => 1,
          "return" => htmlspecialchars(_SITE_URL_ . "template/index.html"),
  //						"cancel_return"	=> htmlspecialchars($_POST["cancelURL"]),
          "notify_url" => htmlspecialchars(_SITE_URL_ . "ipn.php"),
          "custom" => "");
      $envURL = "https://www.paypal.com";

      $buttonReturn = EWPServices::encryptButton($buttonParams, $myCert, $myKey,
              "", $paypalCert, $envURL, BUTTON_IMAGE);
      if (!$buttonReturn["status"]) {
  //	Utils::PPError($buttonReturn["error_msg"], $buttonReturn["error_no"]);
  //	exit;
        $button = "";
      } else {
        $button = $buttonReturn["encryptedButton"];
      }
    }
    return View::viewGoods($goodsName, $goodsId, $price, $currency, $fileName, $button);
  }
          
  function action_testdl(){
    if($this->isLogined()){
      if(isset($_GET['id'])){
        $goodsId = $_GET['id'];
        $dao = new Dao();
        $goods = $dao->getItemById($goodsId);
        if(is_null($goods)){
          return View::error("Not Found Goods");
        }else{
          // 商品情報ダウンロード
          $fileNameLocal = _DATA_DIR_ . $goods['filenamelocal'];
          $fileData = file_get_contents($fileNameLocal);
          $fileSize = filesize($fileNameLocal);
          if($fileData != false){
                  header("Content-type: " . $goods['contenttype']);
                  header("Content-Transfer-Encoding: binary");
                  header("Content-Disposition: attachment; filename=" . $goods['filename']);
                  header("Content-Length: " . $fileSize);
                  print($fileData);
                  exit();
          }else{
            return View::error("Not Found Goods");
          }          
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_delgoodsform(){
    if($this->isLogined()){
      $dao = new Dao();
      if(isset($_POST['items']) || isset($_GET['id'])){
        if(isset($_POST['items'])){
          $items = $_POST['items'];
        }else{
          $items[] = $_GET['id'];
        }
        return View::delgoodsForm($items);
      }else{
        // 削除対象がない場合、リストを表示
        $itemDb = $dao->selectItem(0, 10000);
        return View::goodsList($itemDb);
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_delgoods(){
    if($this->isLogined()){
      $dao = new Dao();
      if(isset($_POST['items'])){
        $items = $_POST['items'];
        
        // 削除処理
        foreach($items as $id){
          $goods = $dao->getItemById($id);
          if(!is_null($goods)){
            $fileName = $goods['filenamelocal'];
            unlink(_DATA_DIR_ . $fileName);
            $dao->deleteItem($id);
            $dao->deletePermitDLByItem($id);
          }
        }
      }
      $itemDb = $dao->selectItem(0, 10000);
      return View::goodsList($itemDb);
    }else{
      return View::loginForm();
    }   
  }

  function action_editfileform(){
    if($this->isLogined()){
      if(isset($_GET['id'])){
        $goodsId = $_GET['id'];
        $dao = new Dao();
        $goods = $dao->getItemById($goodsId);
        if(!is_null($goods)){
          $fileName = $goods['filename'];
          return View::editFileForm($goodsId, $fileName, $goods['filenamelocal']);
        }else{
          return View::error("Not Found Goods");
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_editfile(){
    if($this->isLogined()){
      if(isset($_POST['orggoodsid'])){
        $goodsId = $_POST['orggoodsid'];
        
        $phpFileSizeMax = ini_get('upload_max_filesize');
        $fileSizeMax = isset($_POST['MAX_FILE_SIZE']) ? $_POST['MAX_FILE_SIZE'] : $phpFileSizeMax;
        if($fileSizeMax > $phpFileSizeMax){
          $fileSizeMax = $phpFileSizeMax;
        }
        
        $errMsg = array();
        
        // 既に登録されているかのチェック
        $dao = new Dao();
        $goods = $dao->getItemById($goodsId);
        if(is_null($goods)){
          $errMsg[] = "Not Found Goods";
          $oldFileName = "";
        }else{
          $oldFileNameLocal = $goods['filenamelocal'];
          $fileNameLocal = $oldFileNameLocal;
          $oldFileName = $goods['filename'];
          $goodsName = $goods['item_name'];
          $price = $goods['price'];
          $currency = $goods['mc_currency'];
        }
        
        // アップロードファイルのチェック
        $isUploadOk = false;
/*        
        foreach ($_FILES['datafile']['error'] as $key => $error){
          if($error == UPLOAD_ERR_OK){
            $isUploadOk = true;
          }
        }
 */
        if($_FILES['datafile']['error'] == UPLOAD_ERR_OK){
          $isUploadOk = true;
        }
        if($isUploadOk){
          $fileSize = isset($_FILES['datafile']['size']) ? $_FILES['datafile']['size'] : 0;
          if($fileSize == 0){
            $errMsg[] = "Goods File";
          }else if($fileSize > $fileSizeMax){
            $errMsg[] = "Goods File Too Big";
          }
        }else{
          $errMsg[] = "Goods File Upload False";
        }
        if(count($errMsg) == 0){
          // 以前のファイルを削除
          unlink(_DATA_DIR_ . $oldFileNameLocal);
          
          // 登録処理
          $fileName = $_FILES['datafile']['name'];
          $tmpFileName = $_FILES['datafile']['tmp_name'];
          $fileType = $_FILES['datafile']['type'];
          $fileNameLocal = uniqid("", true);
          if(move_uploaded_file($tmpFileName, _DATA_DIR_ . $fileNameLocal)){
            $dao->updateItemFile($goodsId, $fileName, $fileNameLocal, $fileType, $fileSize);
          }else{
            $errMsg[] = "Goods File Move False";
          }
        }
        
        if(count($errMsg) > 0){
          return View::editFileForm($goodsId, $oldFileName, $fileNameLocal, $errMsg);
        }
        // 商品情報表示
        return $this->viewGoods($dao, $goodsName, $goodsId, $price, $currency, $fileName);
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_editgoodsform(){
    if($this->isLogined()){
      if(isset($_GET['id'])){
        $goodsId = $_GET['id'];
        $dao = new Dao();
        $goods = $dao->getItemById($goodsId);
        if(!is_null($goods)){
          return View::editForm($goodsId, $goods);
        }else{
          return View::error("Not Found Goods");
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_editgoods(){
    if($this->isLogined()){
      if(isset($_POST['goodsname'])
              && isset($_POST['orggoodsid'])
              && isset($_POST['goodsid'])
              && isset($_POST['goodsprice'])
              && isset($_POST['currency'])){
        $goodsName = $_POST['goodsname'];
        $goodsId = $_POST['goodsid'];
        $price = $_POST['goodsprice'];
        $currency = $_POST['currency'];
        $goodsIdOrg = $_POST['orggoodsid'];
                
        $errMsg = array();
        if(mb_strlen($goodsName) == 0){
          $errMsg[] = "Goods Name";
        }else{
          $goodsName = mb_substr($goodsName, 0, 199);
        }
        if(mb_strlen($goodsId) == 0){
          $errMsg[] = "Goods Id";
        }else{
          $goodsId = mb_substr($goodsId, 0, 199);
        }
        if(mb_strlen($currency) == 0){
          $errMsg[] = "Goods Currency";
        }else{
          $currency = mb_substr($currency, 0, 5);
        }
        if(is_numeric($price)){
          if($price < 0){
            $price = 0;
          }
        }else{
          $price = 0;
        }
        if($price == 0){
          $errMsg[] = "Goods Price";
        }
        
        // 既に登録されているかのチェック
        $dao = new Dao();
        $ret = $dao->getItemById($goodsIdOrg);
        if(is_null($ret)){
          $errMsg[] = "Not Found Goods";
        }else{
          $fileName = $ret['filename'];
        }
        
        if(count($errMsg) == 0){
          // 編集処理
            $dao->updateItemInfo($goodsIdOrg, $goodsId, $goodsName,  $price, $currency);
        }
        
        if(count($errMsg) > 0){
          $infoPart = array(
              'item_name' => $goodsName,
              'item_number' => $goodsId,
              'price' => $price,
              'mc_currency' => $currency
              );
          return View::editForm($goodsIdOrg, $infoPart, $errMsg);
        }
        // 商品情報表示
        return $this->viewGoods($dao, $goodsName, $goodsId, $price, $currency, $fileName);
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_regform(){
    if($this->isLogined()){
      return View::regForm(true, "");
    }else{
      return View::loginForm();
    }   
  }
  
  function action_reggoods(){
    if($this->isLogined()){
      if(isset($_POST['goodsname'])
              && isset($_POST['goodsid'])
              && isset($_POST['goodsprice'])
              && isset($_POST['currency'])){
        $goodsName = $_POST['goodsname'];
        $goodsId = $_POST['goodsid'];
        $price = $_POST['goodsprice'];
        $currency = $_POST['currency'];
        
        $phpFileSizeMax = ini_get('upload_max_filesize');
        $fileSizeMax = isset($_POST['MAX_FILE_SIZE']) ? $_POST['MAX_FILE_SIZE'] : $phpFileSizeMax;
        if($fileSizeMax > $phpFileSizeMax){
          $fileSizeMax = $phpFileSizeMax;
        }
        
        $errMsg = array();
        if(mb_strlen($goodsName) == 0){
          $errMsg[] = "Goods Name";
        }else{
          $goodsName = mb_substr($goodsName, 0, 199);
        }
        if(mb_strlen($goodsId) == 0){
          $errMsg[] = "Goods Id";
        }else{
          $goodsId = mb_substr($goodsId, 0, 199);
        }
        if(mb_strlen($currency) == 0){
          $errMsg[] = "Goods Currency";
        }else{
          $currency = mb_substr($currency, 0, 5);
        }
        if(is_numeric($price)){
          if($price < 0){
            $price = 0;
          }
        }else{
          $price = 0;
        }
        if($price == 0){
          $errMsg[] = "Goods Price";
        }
        
        // 既に登録されているかのチェック
        $dao = new Dao();
        $ret = $dao->getItemById($goodsId);
        if(!is_null($ret)){
          $errMsg[] = "Exist Same Goods";
        }
        
        // アップロードファイルのチェック
        $isUploadOk = false;
/*        
        foreach ($_FILES['datafile']['error'] as $key => $error){
          if($error == UPLOAD_ERR_OK){
            $isUploadOk = true;
          }
        }
 */
        if($_FILES['datafile']['error'] == UPLOAD_ERR_OK){
          $isUploadOk = true;
        }
        if($isUploadOk){
          $fileSize = isset($_FILES['datafile']['size']) ? $_FILES['datafile']['size'] : 0;
          if($fileSize == 0){
            $errMsg[] = "Goods File";
          }else if($fileSize > $fileSizeMax){
            $errMsg[] = "Goods File Too Big";
          }
        }else{
          $errMsg[] = "Goods File Upload False";
        }
        if(count($errMsg) == 0){
          // 登録処理
          $fileName = $_FILES['datafile']['name'];
          $tmpFileName = $_FILES['datafile']['tmp_name'];
          $fileType = $_FILES['datafile']['type'];
          $fileNameLocal = uniqid("", true);
          if(move_uploaded_file($tmpFileName, _DATA_DIR_ . $fileNameLocal)){
            $ret = $dao->insertItem($goodsId, $goodsName, $fileName, $fileNameLocal, 
                    "", $fileType, $fileSize, $price, $currency);
            if($ret === false){
              $errMsg[] = "DB Error";
            }
          }else{
            $errMsg[] = "Goods File Move False";
          }
        }
        
        if(count($errMsg) > 0){
          $infoPart = array(
              'name' => $goodsName,
              'id' => $goodsId,
              'price' => $price,
              'currency' => $currency
              );
          return View::regForm($infoPart, "", false, $errMsg);
        }
        // 商品情報表示
        return $this->viewGoods($dao, $goodsName, $goodsId, $price, $currency, $fileName);
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_viewlog(){
    $pageNum = self::PageNumLog;
    if($this->isLogined()){
      $offset = isset($_GET['offset']) ? $_GET['offset'] : 0;
      
      $dao = new Dao();
      $count = $dao->countLog();
      $logDb = $dao->selectLog($offset, $pageNum);
      
      $pageNavi = new PageNavigation($count, $offset, $pageNum);
      return View::logList($logDb, $pageNavi);
    }else{
      return View::loginForm();
    }   
  }

  function action_viewerrlog(){
    $pageNum = self::PageNumLog;
    if($this->isLogined()){
      $offset = isset($_GET['offset']) ? $_GET['offset'] : 0;
      
      $dao = new Dao();
      $count = $dao->countErrLog();
      $logDb = $dao->selectErrLog($offset, $pageNum);
      
      $pageNavi = new PageNavigation($count, $offset, $pageNum);
      return View::logErrList($logDb, $pageNavi);
    }else{
      return View::loginForm();
    }   
  }

  function action_viewcert(){
    if($this->isLogined()){      
      return $this->viewcert();
    }else{
      return View::loginForm();
    }   
  }
  
  /**
   * 証明書関係が登録されているか
   * @param Dao $dao
   * @return boolean
   */
  private function checkCert($dao){
    $certId = $dao->getSiteData("certid");
    if (is_null($certId)) {
      return false;
    }
    $paypalCert = $dao->getSiteData("paypalcert");
    if (is_null($paypalCert)) {
      return false;
    }
    $myCert = $dao->getSiteData("mycert");
    if (is_null($myCert)) {
      return false;
    }
    $myPrvkey = $dao->getSiteData("myprvkey");
    if (is_null($myPrvkey)) {
      return false;
    }
    return true;
  }
  
  private function viewcert() {
    $errMsg = array();
    $dao = new Dao();
    $certId = $dao->getSiteData("certid");
    if (is_null($certId)) {
      $certId = "";
      $errMsg[] = "Not Found CertID";
    }
    $paypalCert = $dao->getSiteData("paypalcert");
    if(is_null($paypalCert)){
      $errMsg[] = "Not Found PayPal Cert";
    }
    $myCertFile = $dao->getSiteData("mycert");
    if(is_null($myCertFile)){
      $errMsg[] = "Not Found My Cert";
    }
    $myKey = $dao->getSiteData("myprvkey");
    if(is_null($myKey)){
      $errMsg[] = "Not Found My Key";
    }
    // 作成日
    $regDate = $dao->getSiteData("regcert");
    if(is_null($regDate)){
      $regDate = "";
    }

    return View::certForm($certId, $regDate, $errMsg);
  }

  function action_uploadmykey(){
    if($this->isLogined()){
      if(isset($_FILES['mykey']) && isset($_FILES['mycert'])){
        $myKeyFile = $_FILES['mykey'];
        $myCertFile = $_FILES['mycert'];
        
        $dao = new Dao();

        if($myKeyFile['error'] == UPLOAD_ERR_OK){
          // 登録処理
          $tmpFileName = $myKeyFile['tmp_name'];
          $myKey = file_get_contents($tmpFileName);
          $dao->deleteSite("myprvkey");
          $dao->insertSite("myprvkey", $myKey);          
        }
        
        if($myCertFile['error'] == UPLOAD_ERR_OK){
          // 登録処理
          $tmpFileName = $myCertFile['tmp_name'];
          $myCert = file_get_contents($tmpFileName);
          $dao->deleteSite("mycert");
          $dao->insertSite("mycert", $myCert);  
        }
        
        return $this->viewcert();
      }else{
        return $this->viewcert();
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_regcert(){
    if($this->isLogined()){
      if(isset($_POST['certid'])){
        $certId = $_POST['certid'];
        $paypalCertFile = $_FILES['paypalcert'];
        
        $dao = new Dao();
        if(strlen($certId) > 0){
          $dao->deleteSite("certid");
          $dao->insertSite("certid", $certId);
        }

        if($paypalCertFile['error'] == UPLOAD_ERR_OK){
          // 登録処理
          $tmpFileName = $paypalCertFile['tmp_name'];
          $paypalCert = file_get_contents($tmpFileName);
          $dao->deleteSite("paypalcert");
          $dao->insertSite("paypalcert", $paypalCert);
        }
       
        return $this->top();
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_mykeyform(){
    if($this->isLogined()){
      return View::mykeyForm();
    }else{
      return View::loginForm();
    }   
  }

  function action_generatekey(){
    if($this->isLogined()){
      if(isset($_POST['country'])
              && isset($_POST['state'])
              && isset($_POST['city'])
              && isset($_POST['company'])
              && isset($_POST['team'])
              && isset($_POST['yourname'])
              && isset($_POST['email']) ){
        $country = $_POST['country'];
        $state = $_POST['state'];
        $city = $_POST['city'];
        $company = $_POST['company'];
        $team = $_POST['team'];
        $yourname = $_POST['yourname'];
        $email = $_POST['email'];
        
        $errMsg = array();
        if(strlen($country) != 2){
          $errMsg[] = "Failure Cert Country";
        }
        if(strlen($state) == 0){
          $errMsg[] = "Failure Cert state";
        }
        if(strlen($city) == 0){
          $errMsg[] = "Failure Cert city";
        }
        if(strlen($company) == 0){
          $errMsg[] = "Failure Cert company";
        }
        if(strlen($team) == 0){
          $errMsg[] = "Failure Cert team";
        }
        if(strlen($yourname) == 0){
          $errMsg[] = "Failure Cert name";
        }
        if(validateEmailString($email) !== true){
          $errMsg[] = "Failure Cert email";
        }
        
        if(count($errMsg) > 0){
          return View::mykeyForm($errMsg);
        }
        
        $config = array(
          "digest_alg" => "sha1",
          "private_key_bits" => 1024,
          "private_key_type" => OPENSSL_KEYTYPE_RSA
        );
        $res = openssl_pkey_new($config);
        if($res == false){
          $errMsg[] = "Failure My Key";
          return View::mykeyForm($errMsg);
        }
        openssl_pkey_export($res, $privKey);

        $dn = array(
            "countryName" => $country,
            "stateOrProvinceName" => $state,
            "localityName" => $city,
            "organizationName" => $company,
            "organizationalUnitName" => $team,
            "commonName" => $yourname,
            "emailAddress" => $email
        );

        $csr = openssl_csr_new($dn, $res);
        if($csr == false){
          $errMsg[] = "Failure My Cert";
          return View::mykeyForm($errMsg);
        }
        $sscert = openssl_csr_sign($csr, null, $res, 365);
        //openssl_csr_export($csr, $csrout);
        $ret = openssl_x509_export($sscert, $certout);
                
        $dao = new Dao();

        $dao->deleteSite("myprvkey");
        $dao->insertSite("myprvkey", $privKey);

        $dao->deleteSite("mycert");
        $dao->insertSite("mycert", $certout);  

        $dao->deleteSite("regcert");
        $dao->insertSite("regcert", date("Y/m/d", time())); 
        
        return View::generatedKey();
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_downloadmykey(){
    if($this->isLogined()){
      $dao = new Dao();
      $mykey = $dao->getSiteData("myprvkey");
      if (is_null($mykey)) {
        return View::error("Not Found My Key");
      } else {
        // ダウンロード
        $fileSize = strlen($mykey);
        header("Content-type: text/plain");
        header("Content-Transfer-Encoding: binary");
        header("Content-Disposition: attachment; filename=my-prvkey.pem");
        header("Content-Length: " . $fileSize);
        print($mykey);
        exit();
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_downloadmycert(){
    if($this->isLogined()){
      $dao = new Dao();
      $myCert = $dao->getSiteData("mycert");
      if (is_null($myCert)) {
        return View::error("Not Found My Cert");
      } else {
        // ダウンロード
        $fileSize = strlen($myCert);
        header("Content-type: text/plain");
        header("Content-Transfer-Encoding: binary");
        header("Content-Disposition: attachment; filename=my-pubcert.pem");
        header("Content-Length: " . $fileSize);
        print($myCert);
        exit();
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_passform(){
    if($this->isLogined()){
      return View::passForm();
    }else{
      return View::loginForm();
    }   
  }

  function action_setpass(){
    if($this->isLogined()){
      if(isset($_POST['oldpass'])
              && isset($_POST['newpass1'])
              && isset($_POST['newpass2'])){
        $oldPass = $_POST['oldpass'];
        $newPass1 = $_POST['newpass1'];
        $newPass2 = $_POST['newpass2'];
        
        $dao = new Dao();        
        $errMsg = array();               
        if(strcmp($newPass1, $newPass2) == 0){
          if(validatePasswordString($newPass1, 4, 16) !== true){
            $errMsg[] = "No Good Password";
          }          
        }else{
          $errMsg[] = "Not Same Password";
        }
        
        if(count($errMsg) == 0){
          $hashed_password = $dao->getSiteData("password");
          if(crypt($oldPass, $hashed_password) == $hashed_password){
            // パスワードの変更処理
            $dao->deleteSite("password");
            $dao->insertSite("password", crypt($newPass1));
            return $this->top();
          }else{
            $errMsg[] = "Correct Old Password";
          }
        }
        
        return View::passForm($errMsg);
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }

  function action_dellogform(){
    if($this->isLogined()){      
      return View::delLogForm();
    }else{
      return View::loginForm();
    }   
  }

  function action_dellog(){
    if($this->isLogined()){
      if(isset($_POST['term'])){
        $term = $_POST['term'];
        
        $dao = new Dao();
        $errMsg = array();
        if(($term < 0) || ($term > 100)){
          $errMsg[] = "Delete Log Term";
        }
        
        if(count($errMsg) == 0){
          $dao->deleteTradeOld($term);
          $dao->deleteRefundedOld($term);
          $dao->deletePermitDLOld();
          $dao->deleteLogOld($term);
          return View::deletedLog();
        }
        
        return View::delLogForm(3, $errMsg);
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::loginForm();
    }   
  }
  
  function action_login() {
    if(defined("_SITE_URL_")){
      if(isset($_POST['ctrlpass'])){
        if($this->isLogined()){
          return $this->top();
        }else{
          $dao = new Dao();
          $hashed_password = $dao->getSiteData("password");
          $user_input = $_POST['ctrlpass'];
          if(crypt($user_input, $hashed_password) == $hashed_password){
            $this->setLogin();
            $dao->insertLog("login");
            return $this->top();
          }
          $dao->insertErrLog("login failure");
          return View::loginForm(true);
        }
      }else{
        return View::error("WrongAccess");
      }
    }else{
      return View::error("Not SET File");
    }
  }

  private function top(){
    $initCheck = array();
    $dao = new Dao();
    // パスワードが初期値か？
    $hashed_password = $dao->getSiteData("password");
    if(crypt("0000", $hashed_password) == $hashed_password){
      $initCheck['password'] = true;
    }
    
    // 商品があるか
    $goodsDb = $dao->selectItem(0, 1);
    if(count($goodsDb) == 0){
      $initCheck['no goods'] = true;
    }
    
    // 取引があるか
    $tradeCnt = $dao->countPermitDL();
    if($tradeCnt == 0){
      $initCheck['no trade'] = true;
    }

    // 証明書の確認
    if(! $this->checkCert($dao)){
      $initCheck['cert'] = true;
    }
/*    
    $paypalCertFile = _DATA_DIR_ . "paypal_cert.pem";
    if(!file_exists($paypalCertFile)){
      $initCheck['cert'] = true;
    }
    $myKeyFile = _DATA_DIR_ . "my-prvkey.pem";
    if(!file_exists($myKeyFile)){
      $initCheck['myKey'] = true;
    }
    $myCertFile = _DATA_DIR_ . "my-pubcert.pem";
    if(!file_exists($myCertFile)){
      $initCheck['myCert'] = true;
    }
*/    
    return View::loginTop($initCheck);
  }

  function action_help() {
    include_once('RtHelp.php');
    $sec = isset($_GET['s']) ? $_GET['s'] : ""; 
    return View::help($sec);
  }
    
  /**
   * エラー表示
   * 未確認
   * @return type 
   */
  function action_viewerror() {
    if (isset($_GET['err'])) {
      return View::error($_GET['err']);
    } else {
      return View::error("FailureError");
    }
  }

  function action_top() {
    if(defined("_DATA_DIR_")){  
      if(!isset($_SESSION['_PRG_MODE_'])){
        $downloadFile = file_get_contents("download.php");
        $p = mb_strpos($downloadFile, "sample");
        if($p === false){
          $_SESSION['_PRG_MODE_'] = RT::VersionNormal;
        }else{
          $_SESSION['_PRG_MODE_'] = RT::VersionSample;
        }
      }
      
      if($this->isLogined()){
        return $this->top();
      }else{
        return View::loginForm();
      }      
    }else{
      return View::moveWizForm();
    }
  }

  private function setLogin(){
    $_SESSION["LOGINED"] = true;
  }
  
  private function isLogined(){
    if (isset($_SESSION["LOGINED"])) {
      return true;
    } else {
      return false;
    }    
  }
  
  function __construct($name) {
    $this->urlName = $name;
  }

  /**
   * 指定の引数の名前に与えられたメソッドが存在するか。
   * 例　関数の引数にstatusが与えられた場合、?status=func1 でアクセスされると、func1のメソッドが存在するかを調べる
   *
   * @return unknown
   */
  static function isExistActionFunc($name) {
    if (isset($_GET[$name])) {
      $status = "action_" . $_GET[$name];
    } else {
      return false;
    }
    $ret = method_exists('Action', $status);
    return $ret;
  }

  public function action() {
    if (isset($_GET[$this->urlName])) {
      $status = "action_" . $_GET[$this->urlName];
      if (!method_exists($this, $status)) {
        $status = Action::defaultFuncName;
      }
    } else if (isset($_POST[$this->urlName])) {
      $status = "action_" . $_POST[$this->urlName];
      if (!method_exists($this, $status)) {
        $status = Action::defaultFuncName;
      }
    } else {
      $status = Action::defaultFuncName;
    }
    return $this->$status();
  }

}

?>