<?php

/**
 * ページ送りの、「戻る」「次へ」などを判別するクラス
 *  
 */
class PageNavigation {

  public $isNavi;
  public $isPrev;
  public $isNext;
  public $isFirst;
  public $isLast;
  public $firstOffset;
  public $prevOffset;
  public $nextOffset;
  public $lastOffset;

  public $total;
  function __construct($totalNum, $offset, $numInPage) {
    $this->total = $totalNum;
    if ($totalNum <= $numInPage) {
      $this->isNavi = false;
    } else {
      $this->isNavi = true;
    }
    $this->prevOffset = $offset - $numInPage;
    if ($this->prevOffset >= 0) {
      $this->isPrev = true;
    } else {
      $this->isPrev = false;
    }
    $this->nextOffset = $offset + $numInPage;
    if ($this->nextOffset < $totalNum) {
      $this->isNext = true;
    } else {
      $this->isNext = false;
    }
    $v = floor(($totalNum - 1) / $numInPage);
    $this->lastOffset = $v * $numInPage;
    if (($this->lastOffset >= ($this->nextOffset + $numInPage)) && ($this->lastOffset < $totalNum)) {
      $this->isLast = true;
    } else {
      $this->isLast = false;
    }
    $this->firstOffset = 0;
    if ($this->prevOffset <= 0) {
      $this->isFirst = false;
    } else {
      $this->isFirst = true;
    }
  }

  function viewPageNavi($url){
    $first = "&nbsp;&laquo;&nbsp;";
    $prev = "&nbsp;&lt;&nbsp;";
    $next = "&nbsp;&gt;&nbsp;";
    $last = "&nbsp;&raquo;&nbsp;";
    
    $data = "Total&nbsp;[&nbsp;" . $this->total . "&nbsp;]&nbsp;";
    if($this->isFirst){
      $data .=<<<EOD
<a href="{$url}" style="text-decoration: none;">{$first}</a>
EOD;
    }
    if($this->isPrev){
      $offset = $this->prevOffset;
      $data .=<<<EOD
<a href="{$url}&amp;offset={$offset}" style="text-decoration: none;">{$prev}</a>
EOD;
    }
    if($this->isNext){
      $offset = $this->nextOffset;
      $data .=<<<EOD
<a href="{$url}&amp;offset={$offset}" style="text-decoration: none;">{$next}</a>
EOD;
    }
    if($this->isLast){
      $offset = $this->lastOffset;
      $data .=<<<EOD
<a href="index.php?f=usrlist&amp;offset={$offset}" style="text-decoration: none;">{$last}</a>
EOD;
    }
    if(strlen($data) > 0){
      $data = "<div>" . $data . "</div>";
    }
    return $data;
  }  
}

?>
