<?php
/**
 * ページの表示クラス
 * 
 * @version 1.0 (2009/6/19)
 */

require_once 'viewTemplate.php';

/**
 * テンプレートを使った表示クラス
 * 使用例
 * $page = new PageTemplate('foo.html');
 * $page->setArg('part1','これは');
 * $page->setArg('part2','です');
 * $page->view();
 *
 */
class PageTemplate{
	private $headers;
	private $body;
	private $args;
	private $templateString;
	
	function __construct($templateFile = null){
		$this->headers = array();
		$this->body = null;
		if(is_null($templateFile)){
			$this->templateString = null;
		}else{
			$this->loadTemplate($templateFile);
		}
		$this->args = null;
	}
	
	function loadTemplate($templateFile){
		$this->templateString = file_get_contents($templateFile);
	}
	
	function setTemplate($templateString){
		$this->templateString = $templateString;
	}
	
	function setHeader($headerList){
		$this->headers[] = $headerList;
	}

	function setHeaders($headerList){
		$this->headers = $headerList;
	}
	
	function setArgs($args){
		$this->args = $args;
	}
	
	function addArgs($args){
		$this->args = array_merge($this->args, $args);
	}
	
	function setArg($key, $value){
		$this->args[$key] = $value;
	}
	
	function setBody($body){
		$this->body = $body;
	}
	
	function makePage(){
		$this->body = getBodyFromTemplateString($this->templateString, $this->args);
	}
	
	function view($headerClose = true){
		if(!is_null($this->headers)){
			for($i = 0; $i < count($this->headers); $i++){
				header($this->headers[$i]);
			}
		}
		if($headerClose){
			header('Connection: close');
		}
		if(is_null($this->body)){
			$this->makePage();
		}
		if(!is_null($this->body)){
			print $this->body;
		}
	}
}
?>