<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of RtErr
 *
 * @author aoyama
 */
class RT{
  const Title = "PayPalを使った自動販売（ダウンロード）システム";
  const VersionNormal = "正式版";
  const VersionSample = "サンプル版";
  
  const TradeId = "取引ID";
  const GoodsName = "商品名";
  const GoodsId = "商品ID";
  const GoodsIdOrg = "元の商品ID";
  const GoodsPrice = "価格";
  const GoodsFileName = "ファイル名";
  const GoodsFileNameOrg = "元のファイル名";
  const GoodsFileNameLocal = "ローカルのファイル名";
  const Currency = "通貨";
  const GoodsFile = "ファイルの指定";
  const PayerEmail = "購入者のメール";
  const PayerName = "購入者";
  const DownloadCnt = "ダウンロード回数";
  const TradeDate = "取引日";
  const LimitDate = "ダウンロード期限";
  const EmailBuyer = "相手のメールアドレス";
  const BuyNow = "購入ボタン";
  const BuyNowNote = "ホームページに下記のタグを貼り付けてください。";
  const Help = "ヘルプ";
  
  const BtnReg = "登録";
  const BtnEdit = "修正";
  const BtnDel = "削除";
  const BtnNext = "次へ";
  const BtnDelCheck = "チェックした商品を削除";

  const BtnEditGoodsInfo = "商品情報の修正";
  const BtnEditGoodsFile = "商品ファイルの変更";
  const BtnDownLoad = "ダウンロード";
  
  const BtnDetail = "詳細";
  
  const BtnStopDl = "ダウンロード停止";
  const BtnExtensionDl = "ダウンロード期限の延長";
  const BtnResetDl = "ダウンロード回数のリセット";
  const BtnResetDlNote = "ダウンロード回数が規定を超えてしまいダウンロードできなくなっている状態を解除します";
  
  const ErrorInputPassword = "正しいパスワードを入力してください。<br>パスワードを忘れた場合は、setupフォルダを再度、アップロードし、set.phpファイルを削除してください。再度、設定ウィザードを実行して、パスワードを設定しなおします。";
  
  
  static function defaultMsg($err) {
    switch ($err) {
      case 'Not SET File':
        $data = "setupフォルダを再度、アップロードし、設定ウィザードを実行して、パスワードを設定してください。";
        break;

      // 商品の登録
      case 'Goods Name':
        $data = "商品名を入力してください。";
        break;
      case 'Goods Id':
        $data = "商品IDを設定してください。";
        break;
      case 'Goods Price':
        $data = "価格を設定してください。";
        break;
      case 'Goods Currency':
        $data = "価格の通貨単位を設定してください。";
        break;
      case 'Goods File':
        $data = "商品のデータファイルを指定してください。";
        break;
      case 'Goods File Too Big':
        $data = "商品のデータファイルがシステムの設定を超えています。";
        break;
      case 'Goods File Upload False':
        $data = "商品のデータファイルのアップロードに失敗しました。";
        break;
      case 'Goods File Move False':
        $data = "商品のデータファイルの処理に失敗しました。サーバーの設定を見直してください。";
        break;

      case 'Not Found Goods':
        $data = "商品のデータが見つかりません。";
        break;
      case 'Exist Same Goods':
        $data = "同じ商品IDが、既に登録されています。";
        break;

      case 'Error Trade ID':
        $data = "取引IDを指定してください。";
        break;
      case 'Same Trade ID':
        $data = "同じ取引IDがあります。別の取引IDを指定してください。";
        break;
      case 'Not Permit':
        $data = "ダウンロード許可がありません。";
        break;
      case 'Buyer Email':
        $data = "メールアドレスを指定してください。";
        break;
      
      case 'Not Same Password':
        $data = "新しいパスワードが一致しません。";
        break;
      case 'No Good Password':
        $data = "新しいパスワードは、英数字４文字以上１６文字未満です。入力しなおしてください。";
        break;
      case 'Correct Old Password':
        $data = "元のパスワードが間違っています。";
        break;

      case 'Not Found CertID':
        $data = "PayPalに登録した証明書IDが、このシステムに登録されていません。";
        break;
      case 'Not Found PayPal Cert':
        $data = "PayPal公開証明書が、このシステムに登録されていません。";
        break;
      case 'Not Found My Cert':
        $data = "自分の公開証明書が、このシステムに登録されていません。";
        break;
      case 'Not Found My Key':
        $data = "自分の秘密鍵が、このシステムに登録されていません。";
        break;
      case 'Failure My Key':
        $data = "秘密鍵の生成に失敗しました。";
        break;
      case 'Failure My Cert':
        $data = "公開証明書の生成に失敗しました。";
        break;
      case 'Failure Cert Country':
        $data = "Countryは、２文字です。";
        break;
      case 'Failure Cert state':
        $data = "都道府県を入力してください。";
        break;
      case 'Failure Cert city':
        $data = "市区町村を入力してください。";
        break;
      case 'Failure Cert company':
        $data = "会社名を入力してください。";
        break;
      case 'Failure Cert team':
        $data = "Organization Unit Nameを入力してください。";
        break;
      case 'Failure Cert name':
        $data = "名前を入力してください。";
        break;
      case 'Failure Cert email':
        $data = "正しいEmailを指定してください。";
        break;
      
      case 'Delete Log Term':
        $data = "正しい期間を入力してください。";
        break;
      
      // 定型的なエラー
      case 'DB Error':
        $data = "データベースエラー";
        break;
      
      case 'exceptionTitle':
        $data = "エラー発生";
        break;
      case 'exceptionBody':
        $data = "予想外のエラーが発生しました";
        break;
      case 'ChkDouble':
        $data = "２重に実行しようとしました。メニューの選択から、やり直してください。";
        break;
      case 'Maintenance':
        $data = "現在、メンテナンス中です。しばらく待ってから、アクセスしてください。";
        break;
      case "WrongAccess":
        $data = "不正なアクセスです";
        break;
      case "FailureCron":
        $data = "cronエラー:";
        break;
      case "FailureError":
        $data = "未定義のエラーです";
        break;
      default:
        $data = $err;
    }
    return $data;
  }
  
  // 商品登録
  
  const SubTitleRegGoods = "商品登録";
  const SubTitleEditGoods = "商品情報の修正";
  
  static function regGoodsMsg(){
    $data =<<<EOD
商品を登録してください。<br>
商品IDは、他のIDと異なる値を設定してください。
EOD;
    return $data;
  }

  static function editFileMsg(){
    $data =<<<EOD
商品の新しいデータファイルを指定してください。
EOD;
    return $data;
  }
  
  const SubTitleGoods = "商品情報";
  const SubTitleGoodsList = "商品一覧";
  
  const SubTitleDelGoods = "商品の削除";
  static function delGoodsFormMsg(){
    $data =<<<EOD
次の商品を削除しますか？
EOD;
    return $data;
  } 
  
  const SubTitleUsrList = "購入者一覧";
  const SubTitleTradeDetail = "取引の詳細";
  const SubTitleReEmail = "ダウンロードの案内メール";
  const BtnSendReEmail = "ダウンロードの案内メールを送る";
  
  const SubTitleAddBuyer = "ダウンロード許可";
  static function addBuyerMsg(){
    $data =<<<EOD
手動で、ダウンロード許可を行います。<br>
この操作が必要になるのは、PayPalでの取引があるにもかかわらず、ダウンロード許可が設定されなかった場合
（この場合、ダウンロードを許可したことを知らせるメールが、販売者である　あなたに届きません）や、
PayPal以外の方法で支払いが行われた場合です。<br>
ダウンロード期限を過ぎたり、ダウンロード回数が規定に達して、ダウンロードできなくなった状態を回復するには、
このページではなく、「購入者一覧」で作業を行ってください。
<br>
PayPalでの取引がある場合は、このページでの操作よりも、下記の操作をお勧めします。<br>
<br>
 PayPalのサイトにログインします。<br>
「マイアカウント」タブの「取引履歴」メニュー「IPN取引履歴」を表示します。<br>
過去の履歴を検索し、対象の取引を見つけたら、それを指定して、再送します。<br>
<br>
これにより、PayPalからIPNが再送され、ダウンロードの許可、メールの送信が行われます。
EOD;
    return $data;
  }
  static function sendReEmail(){
    $data = "下記のダウンロード案内メールを送りました。";
    return $data;
  }
  
  const SubTitleLog = "ログ表示";
  const SubTitleErrLog = "エラーログ表示";
  
  // 初期設定の確認
  const InitCheckPass = "パスワードの設定";
  static function initCheckMsg(){
    $data =<<<EOD
初期設定を行ってください。<br>
次の項目が未設定です。
EOD;
    return $data;
  }
  const InitCheckGoods = "商品の登録";
  const InitCheckTrade = "動作確認のため、商品を登録して、購入を試してみましょう。";
  const InitCheckCert = "証明書の登録を行ってください";
  
  const SubTitlePassword = "パスワードの変更";
  const BtnChangePassword = "パスワードを変更する";
  const OldPassword = "現在のパスワード";
  const NewPassword = "新しいパスワード";
  static function editPasswordMsg(){
    $data =<<<EOD
現在のパスワードと、新しいパスワードを入力してください。<br>
新しいパスワードは、同じものを、２か所に入力してください。利用できる文字は、英数字です。
EOD;
    return $data;
  }  
  
  const SubTitleCert = "証明書の登録";
  const CertIdPayPal = "PayPalに登録した証明書ID";
  const CertId = "証明書ID";
  const PayPalCert = "PayPalの公開証明書";
  const PayPalCertSub = "PayPal_cert_pem.txt";
  const MyKey = "自分の秘密鍵";
  const MyKeySub = "my-prvkey.pem";
  const MyCert = "自分の公開鍵証明書";
  const MyCertSub = "my-pubcert.pem";
  const CertNote = "登録、変更する項目のみ入力し、「登録」をクリックしてください。";
  const SubTitleMykey = "秘密鍵、公開鍵証明書の作成";
  const BtnGenerate = "生成し登録する"; 
  const BtnDownloadMykey = "秘密鍵をダウンロード";
  const BtnDownloadMycert = "公開鍵証明書をダウンロード";
  const BtnUpload = "アップロード";
  const BtnGenerate2 = "秘密鍵、公開鍵証明書を生成";
  
  static function certMsg(){
    $data =<<<EOD
このシステムを利用するには、証明書の登録が必要です。
また、証明書の期限が切れる１年毎に更新作業が必要です。<br>
<ol>
<li>ご自分の秘密鍵、公開鍵証明書を持っている場合は、「秘密鍵、公開鍵証明書をアップロード」してください。
持っていない場合は、「秘密鍵、公開鍵証明書を生成」し、「公開鍵証明書」をダウンロードしてください。</li>
<li>PayPalのサイトを開き、PayPalへ公開鍵証明書を登録し、証明書IDを取得します。また、PayPalの公開証明書を取得します。</li>
<li>このシステムに、証明書IDと、PayPalの公開証明書を登録します。</li>
</ol>
<hr>  
<h3>秘密鍵、公開鍵証明書をアップロード</h3>
既に持っている秘密鍵、公開鍵証明書を使う場合は、それらをアップロードしてください。
EOD;
    return $data;
  }

  static function certMsg1(){
    $data =<<<EOD
<h3>秘密鍵、公開鍵証明書を生成して登録</h3>
新しく秘密鍵、公開鍵証明書を生成して登録するには、「秘密鍵、公開鍵証明書を生成」をクリックしてください。<br>
EOD;
    return $data;
  }
  
  static function certMsg2(){
    $data =<<<EOD
登録した秘密鍵、公開鍵証明書をダウンロードして、保管しておいてください。
EOD;
    return $data;
  }

  
  static function certMsg3(){
    $data =<<<EOD
<h3>PayPalへ公開鍵証明書を登録する</h3>
PayPalのサイトを開きます。<br>
エンコードの設定を確認します。<br>
「販売ツール」をクリックし、下の方にある「PayPalボタンの言語コード化」のリンクをクリックします。<br>
「詳細オプション」をクリックします。<br>
その他のエンコードオプション画面で、エンコード方式を「UTF-8」に変更します。<br>
<br> 
「マイアカウント」の「個人設定」を選びます。「販売ツール」をクリックし、下にある「暗号化支払いの設定」をクリックして、「ウェブペイメント証明書」を表示します。<br>
・PayPal公開証明書を「ダウンロード」します。<br>
次に、お客さまの公開証明書の「登録」をクリックして、登録を行います。<br>
・上記で生成した公開鍵証明書（my-pubcert.pem）、または、既に所有している公開鍵証明書を登録します。<br>
・登録したら、証明書IDをメモしてください。下記の設定に入力します。<br>        
EOD;
    return $data;
  }
  
  static function certMsg4(){
    $data =<<<EOD
<h3>サイトへの登録</h3>
<div>
PayPalに登録した公開鍵証明書の証明書IDを入力ボックスに設定してください。<br>
ご自分の秘密鍵、公開鍵証明書、PayPal公開証明書の３つのファイルを指定して登録してください。<br>
別のファイルに変更する場合は、変更する項目のみ設定して、登録してください。
</div>
EOD;
    return $data;
  }

  static function generateMsg(){
    $data =<<<EOD
各項目を設定してください。
EOD;
    return $data;
  }

  static function generatedMsg(){
    $data =<<<EOD
秘密鍵、公開鍵証明書を生成し登録しました。公開鍵証明書をダウンロードしてください。
EOD;
    return $data;
  }
  
  static function generatedMsg2(){
    $data =<<<EOD
公開鍵証明書をダウンロードした後、下記の「次へ」をクリックして、PayPalに登録してください。
EOD;
    return $data;
  }
    
  const SubTitleDelLog = "古いデータの削除";
  const DelLogTitle = "期間（月）";
  static function delLogMsg(){
    $data =<<<EOD
古いデータ（取引、ログなど）を削除します。<br>
何か月より前のデータを削除するか、入力してください。<br>
「3」であれば、３か月より前のデータが削除されます。<br>
また、ダウンロードを許可した期間を過ぎた取引も削除されます。
EOD;
    return $data;
  }
  const DeletedLog = "古いデータを削除しました。";
}

?>
