<?php

/**
 * 表示用のクラス
 * この中では、GETやPOST、_SESSIONを使わない。
 * ここでのみ、string2htmlを使うこと
 *
 */
class View {
  const currentPath = "";

  static function loginTop($initCheck){
    $page = View::defaultPage();
  
    $InitNote = RT::initCheckMsg();
    $initCheckMsg = "";
    if(isset($initCheck['password'])){
      $PassTitle = RT::InitCheckPass;
      $initCheckMsg .=<<<EOD
<li>
  <a href="index.php?f=passform">{$PassTitle}</a>
</li>
EOD;
      
    }
    $CertTitle = RT::SubTitleCert;
    if(isset($initCheck['cert']) || isset($initCheck['myKey']) || isset($initCheck['myCert'])){
      $initCheckMsg .=<<<EOD
<li>
  <a href="index.php?f=viewcert">{$CertTitle}</a>
</li>
EOD;
    }    
    if(isset($initCheck['no goods'])){
      $GoodsTitle = RT::InitCheckGoods;
      $initCheckMsg .=<<<EOD
<li>
  <a href="index.php?f=regform">{$GoodsTitle}</a>
</li>
EOD;
    }
    if(isset($initCheck['no trade'])){
      $TradeTitle = RT::InitCheckTrade;
      $initCheckMsg .=<<<EOD
<li>
  {$TradeTitle}
</li>
EOD;
    }

    if(mb_strlen($initCheckMsg) > 0){
      $initCheckMsg =<<<EOD
<div>
  <div>{$InitNote}</div>
  <ul>{$initCheckMsg}</ul>
</div>
EOD;
    }
    $pageArgs['body'] = $initCheckMsg;
    $page->addArgs($pageArgs);    
    return $page;
  }

  static function loginForm($err = false) {
    $page = new PageTemplate(View::currentPath . 'login.html');

    $version = isset($_SESSION['_PRG_MODE_']) ? $_SESSION['_PRG_MODE_'] : ""; 
    $pageArgs['version'] = $version;
    
    $pageArgs['title'] = RT::Title;
    if($err){
      $pageArgs['errMsg'] = RT::ErrorInputPassword;
    }else{
      $pageArgs['errMsg'] = "";
    }
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static function moveWizForm() {
    $page = new PageTemplate(View::currentPath . 'movewiz.html');

    $pageArgs['title'] = RT::Title;
    
    $page->setArgs($pageArgs);
    return $page;
  }

  static function certForm($certId, $regDate, $errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleCert;
    
    $CertIdTitle = RT::CertIdPayPal;
    $CertIdTitle2 = RT::CertId;
    $PayPalCertTitle = RT::PayPalCert . "<br>"
            . "<span style='color:gray;'>(" . RT::PayPalCertSub . ")</span>";
    $MyKeyTitle = RT::MyKey . "&nbsp;"
            . "<span style='color:gray;'>(" . RT::MyKeySub . ")</span>";
    $MyCertTitle = RT::MyCert . "&nbsp;"
            . "<span style='color:gray;'>(" . RT::MyCertSub . ")</span>";
    
    $note = RT::CertNote;
    $btn = RT::BtnReg;
    $btnUpload = RT::BtnUpload;
    $btnDownloadKey = RT::BtnDownloadMykey;
    $btnDownloadCert = RT::BtnDownloadMycert;
    $btnGene = RT::BtnGenerate2;
         
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg0 = RT::certMsg();
    $msg1 = RT::certMsg1();
    $msg2 = RT::certMsg2();
    $msg3 = RT::certMsg3();
    $msg4 = RT::certMsg4();
    
    $data =<<<EOD
{$err}
<div>{$msg0}</div>
<form method="post" action="index.php?f=uploadmykey" enctype="multipart/form-data">
  <input type="hidden" name="MAX_FILE_SIZE" value="10000000" />
  <dl class="cert_table2">
    <dt>{$MyKeyTitle}</dt>
    <dd><input type="file" name="mykey" /></dd>      
    <dt>{$MyCertTitle}</dt>
    <dd><input type="file" name="mycert" /></dd>          
  </dl>
  <div class="note" style="clear:left;"/>
    <input type="submit" value="{$btnUpload}" />
  </div>
</form>
<div>
{$msg1}
</div>
<div style="padding:1em;">
  <a href="index.php?f=mykeyform">{$btnGene}</a>
  &nbsp;&nbsp;Last time:&nbsp;{$regDate}
</div>
<div>{$msg2}</div>
<div style="padding:1em;">
<a href="index.php?f=downloadmykey">{$btnDownloadKey}</a>&nbsp;&nbsp;
<a href="index.php?f=downloadmycert">{$btnDownloadCert}</a>
</div>
<hr>
<div>{$msg3}</div>
<hr>
<div>
{$msg4}
<br>
{$CertIdTitle}:&nbsp;{$certId}
</div>
<form method="post" action="index.php?f=regcert" enctype="multipart/form-data">
  <input type="hidden" name="MAX_FILE_SIZE" value="10000000" />
  <dl class="cert_table">
    <dt>{$CertIdTitle2}</dt>
    <dd><input type="text" name="certid" style="width:200px;" />
    </dd>
    <dt>{$PayPalCertTitle}</dt>
    <dd><input type="file" name="paypalcert" /></dd>
  </dl>
  <div class="note" style="clear:left;"/>
  {$note}
  </div>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function mykeyForm($errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleMykey;
    
//    $OldPassTitle = RT::OldPassword;
//    $NewPassTitle = RT::NewPassword;
    
    $btn = RT::BtnGenerate;
         
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::generateMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f=generatekey">
  <dl class="cert_table">
    <dt>Country Name [JP]</dt>
    <dd><input type="text" name="country" placeholder="JP" value="JP" /></dd>
    <dt>State or Province Name</dt>
    <dd><input type="text" name="state" placeholder="Tokyo" /></dd>  
    <dt>Locality Name</dt>
    <dd><input type="text" name="city" placeholder="Mitaka-shi" /></dd>
    <dt>Organization Name</dt>
    <dd><input type="text" name="company" placeholder="Taro company" /></dd>
    <dt>Organization Unit Name</dt>
    <dd><input type="text" name="team" placeholder="FA team" /></dd>       
    <dt>Common Name</dt>
    <dd><input type="text" name="yourname" placeholder="Taro Yamada or foo.sample.jp" style="width:300px;" /></dd>       
    <dt>Email</dt>
    <dd><input type="text" name="email" placeholder="master@sample.jp" style="width:300px;" /></dd>       
  </dl>
  <div style="clear:left;">
  <input type="submit" value="{$btn}" />
  </div>
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function generatedKey(){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleMykey;
    
    $btnDownloadCert = RT::BtnDownloadMycert;
    $btnNext = RT::BtnNext;
    $msg1 = RT::generatedMsg();
    $msg2 = RT::generatedMsg2();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
<div style="padding:1em;">
<a href="index.php?f=downloadmycert">{$btnDownloadCert}</a>
</div>
<div>{$msg2}</div>
<div style="padding:1em;">
<a href="index.php?f=viewcert">{$btnNext}</a>
</div>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }
  
  static function passForm($errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitlePassword;
    
    $OldPassTitle = RT::OldPassword;
    $NewPassTitle = RT::NewPassword;
    
    $btn = RT::BtnChangePassword;
         
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::editPasswordMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f=setpass">
  <dl class="style_table">
    <dt>{$OldPassTitle}</dt>
    <dd><input type="text" name="oldpass" />
    </dd>
    <dt>{$NewPassTitle}</dt>
    <dd><input type="text" name="newpass1" />
    </dd>  
    <dt>{$NewPassTitle}</dt>
    <dd><input type="text" name="newpass2" />
    </dd>       
  </dl>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function delLogForm($term=3,$errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleDelLog;
    
    $DelLogTitle = RT::DelLogTitle;

    $btn = RT::BtnDel;
         
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::delLogMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f=dellog">
  <dl class="style_table">
    <dt>{$DelLogTitle}</dt>
    <dd><input type="text" name="term" style="width:30px;" value="{$term}" />
    </dd>
  </dl>
  <hr class="clearleft"/>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function deletedLog(){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleDelLog;
    
    $msg = RT::DeletedLog;
             
    $data =<<<EOD
<div>
{$msg}
</div>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function help($section){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::Help;
    
    $msg = "";
    switch ($section){
      case "reggoods1":
        $msg .= "<h3>"  . RtHelp::RegGoods1Title . "</h3>";
        $msg .= "<div>" . RtHelp::regGoods1Body() . "</div>";
        break;
      default:
        $msg .= "<ul>";
        $msg .= "<li><a href='index.php?f=help&amp;s=reggoods1'>" . RtHelp::RegGoods1Title . "</a></li>";
        $msg .= "</ul>";
        break;
    }
             
    $data =<<<EOD
<div>
{$msg}
</div>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }
  
  static function delgoodsForm($items){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleDelGoods;
    
    $msg = RT::delGoodsFormMsg();
    $btnDel = RT::BtnDel;
    
    $body =<<<EOD
<div>{$msg}</div>
<form method="post" action="index.php?f=delgoods">
<dl class="goodslist">
EOD;
    foreach($items as $id){
      $id = string2html($id);
      $body .=<<<EOD
<dt class="goodsid">{$id}</dt>
<dd class="delete">
<input type="hidden" name="items[]" value="{$id}" />
</dd>
EOD;
    }
    $body .=<<<EOD
</dl>
<hr class="clearleft" />
<input type="submit" value="{$btnDel}"/>
EOD;
    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  static function goodsList($items){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleGoodsList;
    
    $btnDel = RT::BtnDelCheck;
    
    $body =<<<EOD
<form method="post" action="index.php?f=delgoodsform">
<dl class="goodslist">
EOD;
    foreach($items as $item){
      $id = $item['item_number'];
      $name = $item['item_name'];
      $price = $item['price'];
      $filename = $item['filename'];
      $currency = $item['mc_currency'];
      $body .=<<<EOD
<dt class="goodsid"><a href="index.php?f=goods&id={$id}">{$id}</a></dt>
<dd class="goodsname">{$name}</dd>
<dd class="filename">{$filename}</dd>
<dd class="price">{$price}&nbsp;{$currency}</dd>
<dd class="delete">
<input type="checkbox" name="items[]" value="{$id}" />
</dd>
EOD;
    }
    $body .=<<<EOD
</dl>
<hr class="clearleft" />
<input type="submit" value="{$btnDel}"/>
EOD;
    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  private static function infoPart($goodsName, $goodsId, $goodsPrice, $currency){    
    $GoodsNameTitle = RT::GoodsName;
    $GoodsIdTitle = RT::GoodsId;
    $GoodsPriceTitle = RT::GoodsPrice;
    $CurrencyTitle = RT::Currency;
    
    $goodsName = string2html($goodsName);
    $goodsId = string2html($goodsId);
            
    $data =<<<EOD
    <dt>{$GoodsNameTitle}</dt>
    <dd><input type="text" name="goodsname" style="width:350px;" value="{$goodsName}" />
    </dd>
    <dt>{$GoodsIdTitle}</dt>
    <dd><input type="text" name="goodsid" value="{$goodsId}" />
    </dd>
    <dt>{$GoodsPriceTitle}</dt>
    <dd><input type="text" name="goodsprice" value="{$goodsPrice}" />
    </dd>
    <dt>{$CurrencyTitle}</dt>
    <dd><input type="text" name="currency" value="{$currency}" />
    </dd>
EOD;
    return $data;
  }
  
  /**
   * 商品登録フォーム表示
   * @param type $infoPart falseの場合、情報部分は表示しない。配列の場合、表示する。trueの場合、空白データ
   * @param type $filePart falseの場合、ファイルの部分は表示しない。文字列の場合、表示する。
   * @param type $edit tureの場合、修正モード
   * @param Array $errMsg 
   * @return type
   */
  static function regForm($infoPart=true, $filePart=false, $edit=false, $errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleRegGoods;

    $GoodsFileTitle = RT::GoodsFile;
   
    if($infoPart === true){
      $info = self::infoPart("", "", "", "JPY");
    }else if($infoPart === false){
      $info = "";
    }else{
      $info = self::infoPart($infoPart['name'], $infoPart['id'], $infoPart['price'], $infoPart['currency']);
    }
    if($filePart === false){
      $file = "";
    }else{
      $file =<<<EOD
    <dt>{$GoodsFileTitle}</dt>
    <dd><input type="file" name="datafile" value="{$filePart}" />
    </dd>
EOD;
    }
    if($edit === false){      
      $mode = "reggoods";
      $btn = RT::BtnReg;
    }else{
      $mode = "editgoods";
      $btn = RT::BtnEdit;
    }
    
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::regGoodsMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f={$mode}" enctype="multipart/form-data">
  <input type="hidden" name="MAX_FILE_SIZE" value="10000000000" />
  <dl class="style_table">
    {$info}
     {$file}       
  </dl>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function editForm($goodsId, $infoPart, $errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleEditGoods;
   
    $info = self::infoPart($infoPart['item_name'], $infoPart['item_number'], $infoPart['price'], $infoPart['mc_currency']);
 
    $GoodsIdTitleOrg = RT::GoodsIdOrg;
    $mode = "editgoods";
    $btn = RT::BtnEdit;
     
    $goodsId = string2html($goodsId);
    
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::regGoodsMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f={$mode}" enctype="multipart/form-data">
  <input type="hidden" name="MAX_FILE_SIZE" value="10000000000" />
  <input type="hidden" name="orggoodsid" value="{$goodsId}" />
  <dl class="style_table">
    <dt>{$GoodsIdTitleOrg}</dt>
    <dd>{$goodsId}</dd>  
    {$info}      
  </dl>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function editFileForm($goodsId, $fileName, $fileNameLocal, $errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleRegGoods;

    $GoodsIdTitleOrg = RT::GoodsId;
    $FileNameOrg = RT::GoodsFileNameOrg;
    $FileNameLocalTitle = RT::GoodsFileNameLocal;
    $GoodsFileTitle = RT::GoodsFile;
    $btn = RT::BtnEdit;
   
    $fileNameLocal = string2html($fileNameLocal);
    
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::editFileMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
{$err}
<form method="post" action="index.php?f=editfile" enctype="multipart/form-data">
  <input type="hidden" name="MAX_FILE_SIZE" value="10000000000" />
<input type="hidden" name="orggoodsid" value="{$goodsId}" />
  <dl class="style_table">
    <dt>{$GoodsIdTitleOrg}</dt>
    <dd>{$goodsId}</dd>
    <dt>{$FileNameOrg}</dt>
    <dd>{$fileName}</dd>
    <dt>{$FileNameLocalTitle}</dt>
    <dd>{$fileNameLocal}</dd>
    <dt>{$GoodsFileTitle}</dt>
    <dd><input type="file" name="datafile" value="" />
    </dd>       
  </dl>
  <input type="submit" value="{$btn}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }
  
  static function viewGoods($goodsName, $goodsId, $goodsPrice, $currency, $goodsFile, $button){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleGoods;

    $GoodsNameTitle = RT::GoodsName;
    $GoodsIdTitle = RT::GoodsId;
    $GoodsPriceTitle = RT::GoodsPrice;
    $GoodsFileNameTitle = RT::GoodsFileName;
    $BuyNow = RT::BuyNow;
    $btnDownload = RT::BtnDownLoad;
    $btnEditGoodsInfo = RT::BtnEditGoodsInfo;
    $btnEditGoodsFile = RT::BtnEditGoodsFile;
    $btnDel = RT::BtnDel;
    $msgBuyNow = RT::BuyNowNote;

    $goodsName = string2html($goodsName);
    $goodsId = string2html($goodsId);
    
    $data =<<<EOD
<dl class="style_table">
  <dt>{$GoodsNameTitle}</dt>
    <dd>{$goodsName}
    </dd>
    <dt>{$GoodsIdTitle}</dt>
    <dd>{$goodsId}
    </dd>
    <dt>{$GoodsPriceTitle}</dt>
    <dd>{$goodsPrice}&nbsp;{$currency}
    </dd>
    <dt>{$GoodsFileNameTitle}</dt>
    <dd>{$goodsFile}
    </dd>
    <dt>{$BuyNow}</dt>
    <dd>{$button}<br>
    <form name="form1" action="" method="">
    {$msgBuyNow}
    <textarea name="text1" style="width:300px;height:100px;" onClick="areaSelect(this)">{$button}</textarea>
    </form>
    </dd>
</dl>
<div>
    <ul class="menu_goods">
    <li><a href="index.php?f=editgoodsform&id={$goodsId}">{$btnEditGoodsInfo}</a></li>
    <li><a href="index.php?f=editfileform&id={$goodsId}">{$btnEditGoodsFile}</a></li>
    <li><a href="index.php?f=testdl&id={$goodsId}">{$btnDownload}</a></li>
    <li><a href="index.php?f=delgoodsform&id={$goodsId}">{$btnDel}</a></li>
    </ul>
</div>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function trade($trade){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleTradeDetail;
 
    $TradeIdTitle = RT::TradeId;
    $GoodsNameTitle = RT::GoodsName;
    $GoodsIdTitle = RT::GoodsId;
    $PayerEmailTitle = RT::PayerEmail;
    $DlTitle = RT::DownloadCnt;
    $TradeDateTitle = RT::TradeDate;
    $LimitDateTitle = RT::LimitDate;
    
    $btnRest = RT::BtnResetDl;
    $btnResetNote = RT::BtnResetDlNote;
    $btnExtension = RT::BtnExtensionDl;
    $btnStop = RT::BtnStopDl;
    $btnSendEmail = RT::BtnSendReEmail;
    
      $id = string2html($trade['item_number']);
      if(is_null($trade['item_name'])){
        $name = "&nbsp;";
      }else{
        $name = string2html($trade['item_name']);
      }
      $tradeId = string2html($trade['txn_id']);
      $email = string2html($trade['payer_email']);
      $cntDl = $trade['downloadcnt'];
      $td = $trade['tradedate'];
      $ld = $trade['limitdate'];
      $tradeDate = date("Y/m/d", $td);
      $limitDate = date("Y/m/d", $ld);       
    $body =<<<EOD
<dl class="style_table">
<dt>{$TradeIdTitle}</dt><dd>{$tradeId}</dd>
<dt>{$GoodsIdTitle}</dt><dd>{$id}</dd>
<dt>{$GoodsNameTitle}</dt><dd>{$name}</dd>
<dt>{$PayerEmailTitle}</dt><dd>{$email}</dd>
<dt>{$DlTitle}</dt><dd>{$cntDl}</dd>
<dt>{$TradeDateTitle}</dt><dd>{$tradeDate}</dd>
<dt>{$LimitDateTitle}</dt><dd>{$limitDate}</dd>
</dl>
<div>
    <ul class="menu_goods">
    <li><a href="index.php?f=sendremail&txn_id={$tradeId}">{$btnSendEmail}</a></li>
    <li><a href="index.php?f=extension&txn_id={$tradeId}">{$btnExtension}</a></li>
    <li><a href="index.php?f=resetdl&txn_id={$tradeId}">{$btnRest}</a><br>&nbsp;<span style='color:gray;'>{$btnResetNote}</span></li>
    <li><a href="index.php?f=stopdl&txn_id={$tradeId}">{$btnStop}</a></li>
    </ul>
</div>
EOD;

    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  static function usrList($usrList, $pageNavi){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleUsrList;
 
    $btnDetail = RT::BtnDetail;
    
    $body = $pageNavi->viewPageNavi("index.php?f=usrlist");
       
    $body .=<<<EOD
<dl class="usrlist">
EOD;
    foreach($usrList as $usr){
      $id = string2html($usr['item_number']);
      if(is_null($usr['item_name'])){
        $name = "&nbsp;";
      }else{
        $name = string2html($usr['item_name']);
      }
      $tradeId = string2html($usr['txn_id']);
      $email = string2html($usr['payer_email']);
      $cntDl = $usr['downloadcnt'];
      $td = $usr['tradedate'];
      $ld = $usr['limitdate'];
      $tradeDate = date("Y/m/d", $td);
      $limitDate = date("y/m/d", $ld);
      $body .=<<<EOD
<dt class="goodsid">{$id}</dt>
<dd class="goodsname">{$name}</dd>
<dd class="email">{$email}</dd>
<dd class="dlcnt">{$cntDl}</dd>
<dd class="tradedate">{$tradeDate}</dd>
<dd class="limitdate">{$limitDate}</dd>
<dd class="txn_id"><a href="index.php?f=trade&amp;txn_id={$tradeId}">{$btnDetail}</a></dd>
EOD;
    }
    $body .=<<<EOD
</dl>
<hr class="clearleft" />
EOD;

    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  static function sentReEmail($payerEmail, $goodsName){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleReEmail;
 
    $GoodsNameTitle = RT::GoodsName;
    $PayerNameTitle = RT::PayerName;
    $goodsName = string2html($goodsName);
    $email = string2html($payerEmail);
    
    $msg = RT::sendReEmail();
    
    $body .=<<<EOD
{$msg}
<dl class="style_table">
  <dt>{$GoodsNameTitle}</dt>
  <dd>{$goodsName}</dd>
  <dt>{$PayerNameTitle}</dt>
  <dd>{$email}</dd>
</dl>
EOD;

    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  private static function viewPageNavi($pageNavi, $url){
    $first = "&nbsp;&laquo;&nbsp;";
    $prev = "&nbsp;&lt;&nbsp;";
    $next = "&nbsp;&gt;&nbsp;";
    $last = "&nbsp;&raquo;&nbsp;";
    
    $data = "";
//    if($pageNavi->isFirst){
      $data .=<<<EOD
<a href="{$url}" style="text-decoration: none;">{$first}</a>
EOD;
//    }
    if($pageNavi->isPrev){
      $offset = $pageNavi->prevOffset;
      $data .=<<<EOD
<a href="{$url}&amp;offset={$offset}">{$prev}</a>
EOD;
    }
    if($pageNavi->isNext){
      $offset = $pageNavi->nextOffset;
      $data .=<<<EOD
<a href="{$url}&amp;offset={$offset}">{$next}</a>
EOD;
    }
    if($pageNavi->isLast){
      $offset = $pageNavi->lastOffset;
      $data .=<<<EOD
<a href="index.php?f=usrlist&amp;offset={$offset}" >{$last}</a>
EOD;
    }
    if(strlen($data) > 0){
      $data = "<div>" . $data . "</div>";
    }
    return $data;
  }

  static function addbuyerForm($goodsList, $tradeId, $buyerEmail="", $selectGoodsId=null, $errMsg=array()){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleAddBuyer;

    $subTitle = RT::SubTitleAddBuyer;
    $TradeIdTitle = RT::TradeId;
    $BuyerEmailTitle = RT::EmailBuyer;
    $GoodsNameTitle = RT::GoodsName;
    $btnSubmit = RT::BtnReg;
       
    $htmlSelect = new HtmlSelect();
    $htmlSelect->setName("goodsid");
    $htmlSelect->setOption($goodsList, $selectGoodsId);
    $goodsId = $htmlSelect->getHtml();
    
    if(count($errMsg) == 0){
      $err = "";
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RT::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
    }
    
    $msg1 = RT::addBuyerMsg();
    
    $data =<<<EOD
<div>
{$msg1}
</div>
<hr>
<h3>{$subTitle}</h3>
{$err}
<form method="post" action="index.php?f=addbuyer">
  <dl class="style_table">
<dt>{$TradeIdTitle}</dt>
<dd>
  <input type="text" name="tradeid" style="width:300px;" value="{$tradeId}" />
</dd>
<dt>{$BuyerEmailTitle}</dt>
<dd><input type="text" name="email" style="width:300px;" value="{$buyerEmail}" /></dd>
<dt>{$GoodsNameTitle}</dt>
<dd>{$goodsId}</dd>       
  </dl>
  <input type="submit" value="{$btnSubmit}" />
</form>
EOD;
    $pageArgs['body'] = $data;
    $page->addArgs($pageArgs);
    return $page;
  }

  static function logList($logList, $pageNavi){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleLog;
     
    $body = $pageNavi->viewPageNavi("index.php?f=viewlog");
       
    $body .=<<<EOD
<dl class="log_table">
EOD;
    foreach($logList as $log){
      $logData = string2html($log['logdata']);
      $logDate = $log['logdate'];

      $body .=<<<EOD
<dt>{$logData}</dt>
<dd>{$logDate}</dd>
EOD;
    }
    $body .=<<<EOD
</dl>
<hr class="clearleft" />
EOD;

    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }

  static function logErrList($logList, $pageNavi){
    $page = View::defaultPage();
    $pageArgs['subTitle'] = RT::SubTitleErrLog;
     
    $body = $pageNavi->viewPageNavi("index.php?f=viewlog");
       
    $body .=<<<EOD
<dl class="log_table">
EOD;
    foreach($logList as $log){
      $logData = string2html($log['logdata']);
      $logDate = $log['logdate'];

      $body .=<<<EOD
<dt>{$logData}</dt>
<dd>{$logDate}</dd>
EOD;
    }
    $body .=<<<EOD
</dl>
<hr class="clearleft" />
EOD;

    $pageArgs['body'] = $body;
    $page->addArgs($pageArgs);
    return $page;    
  }
  
  // TODO 未使用
  static function maintenance() {
    $page = View::simplePage();
    $args['pageBody'] = RTErr::defaultMsg("Maintenance");
    $page->addArgs($args);
    return $page;
  }

  static function error($errType) {
    $page = new PageTemplate(View::currentPath . 'error.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['errMsg'] = RT::defaultMsg($errType);    
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static private function defaultPage() {
    $page = new PageTemplate(View::currentPath . 'default.html');

    $version = isset($_SESSION['_PRG_MODE_']) ? $_SESSION['_PRG_MODE_'] : ""; 
    $pageArgs['title'] = RT::Title;
    $pageArgs['version'] = $version;
    $pageArgs['subTitle'] = "";
    $pageArgs['body'] = "";

    $page->setArgs($pageArgs);
    return $page;
  }

}

?>