<?php
/**
 * テンプレートを表示する関数
 * 例：
 * テンプレート
 * <div>{$foo1}/{$foo2}</div>
 * 
 * 使い方
 * $args['foo1'] = "50";
 * $args['foo2'] = "100";
 * viewTemplate("foo.html", $args);
 * 
 * 結果
 * <div>50/100</div>
 * 
 * @param 
 * @param 変数名をキーとした配列
 * @return string
 */
function viewTemplate($templateFile, $args){
	foreach($args as $key => $value){
		$$key = $value;
	}
	$template = file_get_contents($templateFile);
	$viewData = "print<<<EOD\n" . $template . "\nEOD;\n";
	eval($viewData);
}

/**
 * テンプレートに変数を設定する関数
 * 変数名を指定するタイプ。
 * 
 * 例：
 * テンプレート
 * <div>{$foo1}/{$foo2}</div>
 * 
 * 使い方
 * $args['foo1'] = "50";
 * $args['foo2'] = "100";
 * viewTemplate("foo.html", $args);
 * 
 * 結果
 * <div>50/100</div>
 * 
 * @param 
 * @param 変数名をキーとした配列
 * @return string
 */
function getTemplate($templateFile, $args){
	foreach($args as $key => $value){
		$$key = $value;
	}
	$template = file_get_contents($templateFile);
	$viewData = "\$tmp =<<<EOD\n" . $template . "\nEOD;\n";
	eval($viewData);
	return $tmp;
}

function getBodyFromTemplateString($templateString, $args){
	foreach($args as $key => $value){
		$$key = $value;
	}
	$viewData = "\$tmp =<<<EOD\n" . $templateString . "\nEOD;\n";
	eval($viewData);
	return $tmp;
}

/**
 * テンプレートを変数を設定する関数
 * 変数名を指定しないタイプ
 * 
 * 例：
 * テンプレート
 * <div>%s/%s</div>
 * 
 * 使い方
 * viewTemplate("foo.html", "50", "100");
 * 
 * 結果
 * <div>50/100</div>
 * 
 * @param テンプレートファイルと、そこに埋め込む変数
 * @return string
 */
function getParts(){
	if(func_num_args() == 0){
		return "";
	}
	for($i = 0; $i < func_num_args(); $i++){
		if($i == 0){
			$param[0] = file_get_contents(func_get_arg($i));
		}else{
			$param[$i] = func_get_arg($i);
		}
	}
	$tmp = call_user_func_array("sprintf", $param);
	return $tmp;
}

?>