<?php

/**
 * 表示用のクラス
 * この中では、GETやPOST、_SESSIONを使わない。
 * ここでのみ、string2htmlを使うこと
 *
 */
class ViewWiz {
  const currentPath = "";

  static function wizEmail() {
    $page = new PageTemplate(ViewWiz::currentPath . 'wiz.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitleEmail;

    $body = RtWiz::wizEmail();
    $pageArgs['body'] = $body;
    
    $page->setArgs($pageArgs);
    return $page;
  }

  static function wizEmailFalse() {
    $page = new PageTemplate(ViewWiz::currentPath . 'wiz.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitleEmail;

    $body = RtWiz::wizEmailFalse();
    $pageArgs['body'] = $body;
    
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static function wizEnd() {
    $page = new PageTemplate(ViewWiz::currentPath . 'wiz.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitleEnd;

    $body = RtWiz::wizEnd();
    $pageArgs['body'] = $body;
    
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static function wizDbForm($dbName="", $dbUsr="", $dbPass="", $errType = 0) {
    $page = new PageTemplate(ViewWiz::currentPath . 'dbform.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitleDb;

    switch ($errType){
      case 1:
        $errMsg = RtWiz::dbConnectFalse();
        break;
      case 2:
        $errMsg = RtWiz::dbWriteFalse();
        break;
      default:
        $errMsg = "";
    }
    $pageArgs['errMsg'] = $errMsg;
    
    $pageArgs['dbName'] = $dbName;
    $pageArgs['dbUsr'] = $dbUsr;
    $pageArgs['dbPass'] = $dbPass;
    
    $page->setArgs($pageArgs);
    return $page;
  }
 
  static function startForm($errMsg=array()) {
    $page = new PageTemplate(ViewWiz::currentPath . 'wiz.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitleCheck;

    $btnNext = RtWiz::BtnNext;
    $note = RtWiz::phpMsg();
    
    if(count($errMsg) == 0){
      $err = "";

      $next =<<<EOD
<form method='post' action='index.php?f=wizstart'>
<input type='submit' value='{$btnNext}' />
</form>
EOD;
    }else{
      $err = "<div class='error_note'>";
      foreach($errMsg as $value){
        $err .= "<div>" . RtWiz::defaultMsg($value) . "</div>";
      }
      $err .= "</div>";
      
      $next = "";
    }
    
    $body =<<<EOD
<div>{$note}</div>
{$err}
{$next}
EOD;
    $pageArgs['body'] = $body;
    
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static function wizDirForm($dir1, $dir2, $binDir="", $email="", $siteurl="http://") {
    $page = new PageTemplate(ViewWiz::currentPath . 'wiz.html');

    $pageArgs['title'] = RT::Title;
    $pageArgs['subTitle'] = RtWiz::WizSubTitle1;

    $body = RtWiz::siteInput($email, $siteurl);

    $body .= RtWiz::folder1();
    if(!$dir1){
      $body .= RtWiz::folder1false();
    }
    if(!$dir2){
      $body .= RtWiz::folder2false();
    }

    $body .= RtWiz::folderInput($binDir);
    $pageArgs['body'] = $body;
    
    $page->setArgs($pageArgs);
    return $page;
  }
  
  static function error($errType) {
    $page = new PageTemplate(ViewWiz::currentPath . 'error.html');

    $pageArgs['title'] = "エラー発生";
    $pageArgs['pageBody'] = RtErr::defaultMsg($errType);
    $pageArgs['pageFoot'] = ViewWiz::pageFoot();
    
    $page->setArgs($pageArgs);
    return $page;
  }
/*  
  static private function defaultPage() {
    global $lang;

    $page = new PageTemplate(ViewWiz::currentPath . 'default.html');

    $pageArgs['lang'] = $lang;
    $pageArgs['title'] = RT::SiteTitle;

    $pageArgs['pageFoot'] = ViewWiz::pageFoot();
    $page->setArgs($pageArgs);
    return $page;
  }
*/
    
  static private function pageFoot(){
      return <<<EOD
copyright©2013 PostTips. all rights reserved.
EOD;
  }
}

?>